// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('farrago', ['ionic', 'farrago.controllers', 'farrago.services'])

.run(function($ionicPlatform, user, $rootScope) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    setTimeout(function() {
        //navigator.splashscreen.hide();
    }, 100);
	
    if(typeof analytics !== "undefined") {
        analytics.startTrackerWithId('UA-55837001-2')
    } else {
        console.log("Google Analytics Unavailable");
    }
	
  });
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

    // setup an abstract state for the tabs directive
    .state('tab', {
      url: "/tab",
      abstract: true,
      templateUrl: "templates/tabs.html"
    })
	
	/* Splash */
    .state('tab.splash', {
      url: '/splash',
      views: {
        'splash': {
          templateUrl: 'templates/splash.html',
          controller: 'SplashCtrl'
        }
      }
    })
    // Each tab has its own nav history stack:
	
	/* Featured */
    .state('tab.featured', {
      url: '/featured',
      views: {
        'featured': {
          templateUrl: 'templates/featured.html',
          controller: 'FeaturedCtrl'
        }
      }
    })
	
	/* Series */
    .state('tab.series', {
      url: '/series/:iid',
      views: {
        'series': {
          templateUrl: 'templates/series.html',
          controller: 'SeriesCtrl'
        }
      }
    })
	
	/* My Library */
    .state('tab.library', {
      url: '/library',
      views: {
        'library': {
          templateUrl: 'templates/library.html',
          controller: 'LibraryCtrl'
        }
      }
    })
	
	/* Filters */
    .state('tab.filters', {
      url: '/filters',
      views: {
        'filters': {
          templateUrl: 'templates/filters.html',
          controller: 'FiltersCtrl'
        }
      }
    })
	
	/* Comic */
    .state('tab.comic', {
      url: '/comic/:cid/:pid/:sid',
      views: {
        'comic': {
          templateUrl: 'templates/comic.html',
          controller: 'ComicCtrl'
        }
      }
    })

	/* Settings */
    .state('tab.settings', {
      url: '/settings',
      views: {
        'settings': {
          templateUrl: 'templates/settings.html',
          controller: 'SettingsCtrl'
        }
      }
    })
	
	/* Login */
    .state('tab.login', {
      url: '/login',
      views: {
        'login': {
          templateUrl: 'templates/login.html',
          controller: 'LoginCtrl'
        }
      }
    })
	
	/* Search */
    .state('tab.search', {
      url: '/search',
      views: {
        'search': {
          templateUrl: 'templates/search.html',
          controller: 'SearchCtrl'
        }
      }
    });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/splash');

});

