angular.module('farrago')
    .controller('ComicCtrl', function ($scope, $ionicScrollDelegate, $http, user, comic, $stateParams, $state, $ionicModal, $ionicLoading, util, $ionicPlatform) {


        window.plugins.orientationLock.unlock(); // TODO PORTRAIT MODE
        $scope.isRated = false;
        $http({
            method: 'GET',
            url: BASEURL + 'api/ratings',
            headers: {
                "user-token": user.data.token,
                "user-email": user.data.email
            },
            params: {user_id: user.data.id, issue_id: $stateParams.cid}
        }).
            success(function (data, status, headers, config) {
                $scope.isRated = data.recordFound;
                $scope.averageRating = data.averageRating;
                $scope.totalUsers = data.totalUsers;
                $scope.issueRating =  $scope.averageRating*20;
                //alert('averageRating '+data.averageRating+' totalUsers '+ data.totalUsers+' rate_per '+rate_per);

                $scope.starRating = rate_per;
            }).
            error(function (data, status, headers, config) {
                //Hide Loading spinner
                //alert(' fail '+data);
            });


        //Set page id
        document.body.id = 'comic-page-view';
        comic.getOfflineComics();

        //Set height for document
        document.querySelector('.curr_page').style.height = window.innerHeight + "px";
        document.querySelector('.next_page').style.height = window.innerHeight + "px";
        document.querySelector('.prev_page').style.height = window.innerHeight + "px";

        //Show ad for each page
        var preLoadImage = function (r) {
            //Create the image
            var img = new Image();
            //Callback once the image is ready
            img.onload = function () {
                r.callback && r.callback(r.image);
            }
            //load the image
            img.src = r.image;
        }


        //Comic book functions
        var startbook = function () {

            if (typeof analytics !== "undefined") {
                analytics.trackView(comic.data.title);
            }

            //Turning off ads for now, untill we get something actually form the server
            //var comic_w_ads = comic.data.pages;
            //Create a pages array that we can insert ads into
            var comic_w_ads = JSON.parse(JSON.stringify(comic.data.pages));

            //if(util.online){
            //Inject Comic Book with Ad Placements
            for (var i = 0, counter = 0; i < comic_w_ads.length; i++) {
                counter++;
                if (counter == 4) {
                    comic_w_ads.splice(i, 0, 'ad');
                    counter = 0;
                }
            }
            //}


            //Some defaults
            var page_width = 0,
                page_total = comic_w_ads.length - 1;
            current_page = (typeof $stateParams.pid !== 'undefined') ? +$stateParams.pid : 0;

            //Ad variables
            var showAdCount = 0;
            var showAdEveryXPages = 4;
            var currAdPage = 0;
            var currPageIsAdPage = false;
            var disableAdClickThrough = false;
            var adPages = [
                'http://farrago.monumental-i.com/content/com.farrago.users.Advertisement/7/2HeadedMonster_ad_1536x2048.jpg',
                'http://farrago.monumental-i.com/content/com.farrago.users.Advertisement/11/DarkProphet_Ad.jpg',
                'http://farrago.monumental-i.com/content/com.farrago.users.Advertisement/6/DeucesWild_ad_1536x2048.jpg',
                'http://farrago.monumental-i.com/content/com.farrago.users.Advertisement/10/RLIC_ad_v2.jpg',
                'http://farrago.monumental-i.com/content/com.farrago.users.Advertisement/5/DustBunny_ad_1536x2048.jpg',
                'http://farrago.monumental-i.com/content/com.farrago.users.Advertisement/3/Wacom_CCH_Farrago_Ad_1536x2048.jpg'
            ];
            //Shuffle this array, so the pages
            util.shuffle(adPages);

            //Get Container to store pages
            var container = document.querySelectorAll('#comic-view .scroll');
            var ad_window = '';
            //Set up initial pages
            var $prev_page = angular.element(document.querySelectorAll('.prev_page'));
            var $curr_page = angular.element(document.querySelectorAll('.curr_page'));
            var $next_page = angular.element(document.querySelectorAll('.next_page'));
            var $ad_page = angular.element(document.querySelectorAll('.ad_page'));

            var $prev_page_img = $prev_page[0].getElementsByTagName('img');
            var $curr_page_img = $curr_page[0].getElementsByTagName('img');
            var $next_page_img = $next_page[0].getElementsByTagName('img');

            console.log(this);
            //Intercept all external links from ad container
            function routeAdClick(e) {
                e.preventDefault();
                window.open('_system');
                return false;
            }

            //Keep stats on various items about users reading habits
            var stats = {
                page_prev: 0,
                page_next: 0,
                page_time: [],
                ad_counter: 0
            }


            var _gotoPage = function (pid) {


                //Assign the new page id, with some math throw in to calculate ad positions
                //current_page = pid+1 Math.floor( pid+1 / showAdEveryXPages);

                //Find page based on page id
                for (var i = 0, j = comic_w_ads.length; i < j; i++) {
                    if (comic_w_ads[i] !== "ad" &&
                        comic.data.pages[pid].id === comic_w_ads[i].id) {
                        current_page = i;
                        break;
                    }
                }
                //Set pages to loading state
                $curr_page[0].classList.add('loading');
                $prev_page[0].classList.add('loading');
                $next_page[0].classList.add('loading');

                //remove any animation classes
                $curr_page[0].classList.remove('animate');
                $next_page[0].classList.remove('animate');
                $prev_page[0].classList.remove('animate');

                //Remove page images
                $next_page_img[0].src = 'img/blank.gif';
                ;
                $curr_page_img[0].src = 'img/blank.gif';
                ;
                $prev_page_img[0].src = 'img/blank.gif';
                ;

                //Start loading current page
                //Update current page id
                $curr_page[0].id = 'page_' + current_page;

                //Start loading current page
                var currPageDiv = '#page_' + current_page;
                preLoadImage({
                    image: comic_w_ads[current_page].image_large_url,
                    callback: function (img) {
                        if (typeof document.querySelectorAll(currPageDiv + " img")[0] !== 'undefined') {
                            document.querySelectorAll(currPageDiv + " img")[0].src = img;
                            document.querySelectorAll(currPageDiv)[0].classList.remove('loading');
                        }
                    }
                });

                //Preload prev page if there is one.
                if (current_page !== 0) {

                    //Only update the previous page id if there is a page
                    $prev_page[0].id = 'page_' + (current_page - 1);

                    $prev_page_img[0].src = 'img/blank.gif';
                    $prev_page[0].querySelectorAll('.adcontainer')[0].innerHTML = '';
                    var prevPageDiv = '#page_' + (current_page - 1);

                    //If next page is an add
                    if (comic_w_ads[current_page - 1] === 'ad') {
                        loadAdPage(prevPageDiv);

                        //Standard Page
                    } else {
                        $prev_page[0].classList.add('loading');
                    }

                    preLoadImage({
                        image: comic_w_ads[current_page - 1].image_large_url,
                        callback: function (img) {

                            if (typeof document.querySelectorAll(prevPageDiv + " img")[0] !== 'undefined') {
                                document.querySelectorAll(prevPageDiv + " img")[0].src = img;
                                document.querySelectorAll(prevPageDiv)[0].classList.remove('loading');
                            }
                        }
                    });
                }

                //Preload next page if there is one.
                if (current_page !== page_total) {

                    //Only update page as long as were not at the end.
                    $next_page[0].id = 'page_' + (current_page + 1);
                    $next_page_img[0].src = 'img/blank.gif';

                    $next_page[0].querySelectorAll('.adcontainer')[0].innerHTML = '';
                    var nextPageDiv = '#page_' + (current_page + 1);


                    preLoadImage({
                        image: comic_w_ads[current_page + 1].image_large_url,
                        callback: function (img) {
                            if (typeof document.querySelectorAll(nextPageDiv + " img")[0] !== 'undefined') {
                                document.querySelectorAll(nextPageDiv + " img")[0].src = img;
                                document.querySelectorAll(nextPageDiv)[0].classList.remove('loading');
                            }
                        }
                    });
                }


            }

            //Load Current Page
            preLoadImage({
                image: comic_w_ads[current_page].image_large_url,
                callback: function (img) {
                    $curr_page_img[0].src = img;
                    $curr_page[0].classList.remove('loading');
                }
            });

            //PreLoad Next Page
            preLoadImage({
                image: comic_w_ads[current_page + 1].image_large_url,
                callback: function (img) {
                    $next_page_img[0].src = img;
                    $next_page[0].classList.remove('loading');
                }
            });

            //Angular Version
            $pages = angular.element(document.querySelectorAll('.comic_page'));
            $page = angular.element($pages[current_page]);
            //Non angular version (probably bad juju todo this but works for now)
            page = $page[0];

            /**
             * show page by index
             */
            function showPage(page, animate, callback) {
                var percent = 0;
                $element = $curr_page;

                //Previous page
                if (page === 'prev') {
                    $element = $prev_page;
                    percent = 0;
                }
                //Next Page
                if (page === 'next') {
                    $element = $curr_page;
                    percent = -100;
                }

                if (page == 'curr-prev') {
                    $element = $prev_page;
                    percent = -100;
                }
                setContainerOffset(percent, animate, $element, callback, 'release');
            }


            load_prev_page = function () {

                //If end of book
                console.log(current_page);
                console.log(current_page !== 0);

                if (current_page !== 0 && !container[0].classList.contains('page_turning')) {

                    //Send some analytics to google
                    if (typeof analytics !== "undefined") {
                        analytics.trackEvent('Comic', comic.data.series.title, comic.data.id, current_page);
                    }

                    current_page--;
                    stats.page_prev++;

                    container[0].classList.add('page_turning');

                    return showPage('prev', true, function () {

                        console.log('show prev page');

                        //Remove animation classes
                        container[0].classList.remove('page_turning');
                        container[0].classList.remove('dragging_prev_page');
                        container[0].classList.remove('dragging_curr_page');

                        //Reset Animations
                        $curr_page[0].style['transform'] = '';
                        $curr_page[0].style['-webkit-transform'] = '';

                        $next_page[0].style['transform'] = '';
                        $next_page[0].style['-webkit-transform'] = '';

                        $curr_page[0].classList.remove('animate');
                        $next_page[0].classList.remove('animate');
                        $prev_page[0].classList.remove('animate');

                        //Swap clases between divs
                        $curr_page[0].classList.remove('curr_page');
                        $curr_page[0].classList.add('next_page');

                        $prev_page[0].classList.remove('prev_page');
                        $prev_page[0].classList.add('curr_page');

                        $next_page[0].classList.remove('next_page');
                        $next_page[0].classList.add('prev_page');

                        //Update element pointers
                        $prev_page = angular.element(document.querySelectorAll('.prev_page'));
                        $curr_page = angular.element(document.querySelectorAll('.curr_page'));
                        $next_page = angular.element(document.querySelectorAll('.next_page'));

                        $prev_page_img = $prev_page[0].getElementsByTagName('img');
                        $curr_page_img = $curr_page[0].getElementsByTagName('img');
                        $next_page_img = $next_page[0].getElementsByTagName('img');

                        //Update Page Id's
                        $next_page[0].id = 'page_' + (current_page + 1);
                        $curr_page[0].id = 'page_' + current_page;

                        //Check if current page is an add, if so set a flag
                        if (comic_w_ads[current_page] === 'ad') {
                            currPageIsAdPage = true;
                        } else {
                            currPageIsAdPage = false;
                        }

                        //Preload previous page if there is one
                        if (current_page !== 0) {

                            //Only update the previous page id if there is a page
                            $prev_page[0].id = 'page_' + (current_page - 1);

                            $prev_page_img[0].src = 'img/blank.gif';
                            $prev_page[0].querySelectorAll('.adcontainer')[0].innerHTML = '';
                            var prevPageDiv = '#page_' + (current_page - 1);

                            //If next page is an add
                            if (comic_w_ads[current_page - 1] === 'ad') {
                                loadAdPage(prevPageDiv);
                                //Standard Page
                            } else {
                                $prev_page[0].classList.add('loading');
                            }


                            preLoadImage({
                                image: comic_w_ads[current_page - 1].image_large_url,
                                callback: function (img) {

                                    if (typeof document.querySelectorAll(prevPageDiv + " img")[0] !== 'undefined') {
                                        document.querySelectorAll(prevPageDiv + " img")[0].src = img;
                                        document.querySelectorAll(prevPageDiv)[0].classList.remove('loading');

                                    }
                                }
                            });

                        }

                        return true;

                    });
                }

                return false;
            };
            load_next_page = function (event) {


                //If not end of book
                if (current_page !== page_total && !container[0].classList.contains('page_turning')) {
                    current_page++;
                    stats.page_next++;

                    /*
                     //Show add
                     if(showAdCount === showAdEveryXPages){
                     if(typeof window.plugins !== 'undefined' && typeof window.plugins.AdMob !== 'undefined'){
                     //window.plugins.AdMob.showInterstitialAd();
                     }
                     //Reset ad count
                     showAdCount = 0;

                     //Prepare next ad
                     }else{
                     if(showAdCount == 0 && typeof window.plugins !== 'undefined' && typeof window.plugins.AdMob !== 'undefined'){
                     window.plugins.AdMob.createInterstitialView();
                     }
                     showAdCount++;
                     }*/

                    //Send some analytics to google
                    if (typeof analytics !== "undefined") {
                        analytics.trackEvent('Comic', comic.data.series.title, comic.data.id, current_page);
                    }

                    container[0].classList.add('page_turning');

                    showPage('next', true, function () {

                        console.log('show next page');

                        //Remove Animation classes
                        container[0].classList.remove('page_turning');
                        container[0].classList.remove('dragging_prev_page');
                        container[0].classList.remove('dragging_curr_page');

                        //Reset Animation styles
                        $curr_page[0].style['transform'] = '';
                        $curr_page[0].style['-webkit-transform'] = '';

                        $next_page[0].style['transform'] = '';
                        $next_page[0].style['-webkit-transform'] = '';

                        $curr_page[0].classList.remove('animate');
                        $next_page[0].classList.remove('animate');
                        $prev_page[0].classList.remove('animate');

                        //Swap page classes
                        $curr_page[0].classList.remove('curr_page');
                        $curr_page[0].classList.add('prev_page');

                        $prev_page[0].classList.remove('prev_page');
                        $prev_page[0].classList.add('next_page');

                        $next_page[0].classList.remove('next_page');
                        $next_page[0].classList.add('curr_page');

                        $next_page[0].classList.remove('animate');

                        //Update element pointers
                        $prev_page = angular.element(document.querySelectorAll('.prev_page'));
                        $curr_page = angular.element(document.querySelectorAll('.curr_page'));
                        $next_page = angular.element(document.querySelectorAll('.next_page'));

                        $prev_page_img = $prev_page[0].getElementsByTagName('img');
                        $curr_page_img = $curr_page[0].getElementsByTagName('img');
                        $next_page_img = $next_page[0].getElementsByTagName('img');

                        //Update Page Id's
                        $prev_page[0].id = 'page_' + (current_page - 1);
                        $curr_page[0].id = 'page_' + current_page;

                        //Check if current page is an add, if so set a flag
                        if (comic_w_ads[current_page] === 'ad') {
                            currPageIsAdPage = true;
                        } else {
                            currPageIsAdPage = false;
                        }

                        //Preload next page if there is one
                        if (current_page !== page_total) {

                            //Only update page as long as were not at the end.
                            $next_page[0].id = 'page_' + (current_page + 1);
                            $next_page_img[0].src = 'img/blank.gif';

                            $next_page[0].querySelectorAll('.adcontainer')[0].innerHTML = '';
                            var nextPageDiv = '#page_' + (current_page + 1);

                            //If next page is an ad
                            if (comic_w_ads[current_page + 1] === 'ad') {
                                loadAdPage(nextPageDiv);

                                //Standard Page
                            } else {
                                $next_page[0].classList.add('loading');
                            }


                            preLoadImage({
                                image: comic_w_ads[current_page + 1].image_large_url,
                                callback: function (img) {
                                    if (typeof document.querySelectorAll(nextPageDiv + " img")[0] !== 'undefined') {
                                        document.querySelectorAll(nextPageDiv + " img")[0].src = img;
                                        document.querySelectorAll(nextPageDiv)[0].classList.remove('loading');
                                    }
                                }
                            });
                        }

                        return true;

                    });


                }

                return false;
            };

            //Load an ad into the ad container
            function loadAdPage(page) {

                //Send some data to the goog
                if (typeof analytics !== "undefined") {
                    analytics.trackEvent('ShowAd', comic.data.series.title, comic.data.id, current_page);
                }
                console.log(page);

                var AdMarvel = {
                    encode: function (string) {
                        return escape(this._utf8_encode(string));
                    },

                    _utf8_encode: function (string) {
                        string = string.replace(/\r\n/g, "\n");
                        var utftext = "";

                        for (var n = 0; n < string.length; n++) {

                            var c = string.charCodeAt(n);

                            if (c < 128) {
                                utftext += String.fromCharCode(c);
                            }
                            else if ((c > 127) && (c < 2048)) {
                                utftext += String.fromCharCode((c >> 6) | 192);
                                utftext += String.fromCharCode((c & 63) | 128);
                            }
                            else {
                                utftext += String.fromCharCode((c >> 12) | 224);
                                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                                utftext += String.fromCharCode((c & 63) | 128);
                            }

                        }
                        return utftext;
                    }
                }

                var targetparams = {};
                //targetparams['MSISDN']            = ""; // OPTIONAL - Phone number with country code (ex: 16501234567)
                //targetparams['carrier']      = ""; // OPTIONAL - ID of the carrier
                targetparams['age'] = (typeof user.data.age !== 'undefined') ? "" + user.data.age : ''; // OPTIONAL - Age (ex: 27)
                targetparams['dob'] = '' // OPTIONAL - Date of birth in format yyyy-mm-dd (ex: 2008-05-25)
                /*targetparams['AREA_CODE']    = "408"; // OPTIONAL - Area code (ex: 650)
                 targetparams['POSTAL_CODE']  = "95050"; // OPTIONAL - Postal code (ex: 94123)*/

                targetparams['gender'] = (typeof user.data.gender !== 'undefined') ? "" + user.data.gender : ''; // OPTIONAL - Gender: "m" or "male"", "f" or "female"
                targetparams['curr_page'] = "" + current_page;
                targetparams['book_id'] = (typeof comic.data.id !== 'undefined') ? "" + comic.data.id : '';
                targetparams['series_title'] = comic.data.series.title + " " + comic.data.title;
                targetparams['user_id'] = (typeof user.data.id !== 'undefined') ? "" + user.data.id : '';

                /*targetparams['GEOLOCATION']  = ""; // OPTIONAL - Latitude and longitude (ex: 32.9014,-117.2079)
                 targetparams['DMA']          = ""; // OPTIONAL - Designated Marketing Area code (ex: 807)
                 targetparams['ETHNICITY']    = ""; // OPTIONAL - Ethnicity:0-African American,1-Asian,2-Hispanic,3-White,4-Other
                 targetparams['SEEKING']      = ""; // OPTIONAL - Gender interested in: "m" or "male"", "f" or "female", "both"
                 targetparams['INCOME']       = ""; // OPTIONAL - Income (ex: 50000)
                 targetparams['MARITAL']      = ""; // OPTIONAL - Marital status: "single" or "married"
                 targetparams['EDUCATION']    = ""; // OPTIONAL - Education level:0-No College,1-College Degree,2-Graduate School
                 targetparams['KEYWORDS']     = ""; // OPTIONAL - Space delimited keywords (ex: MOVIE CATS FUNNY)
                 targetparams['MARKUP']       = ""; // OPTIONAL - Your site markup: "xhtml" (default), "wml" or "chtml"
                 targetparams['ENCODING']     = ""; // OPTIONAL - Your desired encoding: "utf8" (default), "sjis"
                 targetparams['JAVASCRIPT']   = ""; // OPTIONAL - If you support javascript ads (i.e. iPhone): "yes" (default) or "no"*/

                targetparams['TYPE'] = "banner"; // OPTIONAL - Desired type of ad (banner is often back filled by text): "mixed" (default), "banner", "text"
                /*targetparams['UNIQUE_ID']    = ""; // OPTIONAL - Pass in a unique id for frequency capping
                 targetparams['IDFA']				  =  ""; // OPTIONAL - Unique id for an iOS device. */
                /* targetparams['AD_TRACKING_ENABLED']		  =  ""; // OPTIONAL - YES= Enabled/Opt In, NO= Disabled/Opt Out. */
                targetparams['ANDROID_ID'] = (typeof device !== 'undefined' && device.uuid !== null ) ? "" + device.uuid : ''; // OPTIONAL - Unique id for an android device.
                /*targetparams['ANDROID_ADVERTISING_ID']	  =  ""; // OPTIONAL - Unique user specific android id
                 targetparams['ANDROID_ADVERTISING_ID_OPT_OUT'] =  ""; // OPTIONAL - 0= Opt In, 1= Opt Out*/

                var targetparams_str = "";
                for (var key in targetparams) {
                    if (targetparams_str != "") {
                        targetparams_str += "||";
                    }
                    targetparams_str += key + "=>" + targetparams[key];
                }

                //Grab An ad
                $http({
                    method: 'GET',
                    url: 'http://ads.admarvel.com/fam/phoneGetAd.php',
                    params: {
                        site_id: "96453",
                        partner_id: '38baedc2068d93e3',
                        timeout: 5000,
                        version: '1.5.1',
                        language: 'javascript',
                        format: 'wap',
                        //phone_headers: "REMOTE_ADDR=>66.194.102.6||HTTP_USER_AGENT=>"+navigator.userAgent,
                        target_params: targetparams_str
                    }
                }).
                    success(function (data, status, headers, config) {
                        //If we have an ad lets serve that
                        if (data !== "") {
                            document.querySelectorAll(page + ' .adcontainer')[0].innerHTML = data;
                            document.querySelectorAll(page)[0].classList.remove('loading');
                            if (data.match(/img/g).length === 1) {
                                document.querySelector('.adcontainer img').classList.add('scale');
                            }
                            //Else lets grab an add from farragos servers
                        } else {

                            var adImage = document.createElement('img');
                            adImage.src = adPages[currAdPage];
                            document.querySelectorAll(page + ' .adcontainer')[0].appendChild(adImage);
                            document.querySelectorAll(page)[0].classList.remove('loading');
                            if (typeof adPages[currAdPage + 1] !== 'undefined') {
                                currAdPage++;
                            } else {
                                currAdPage = 0;
                            }
                        }

                        var links = document.querySelectorAll(page + ' .adcontainer a');

                        for (var i = 0; i < links.length; ++i) {
                            links[i].onclick = function () {

                                if (!disableAdClickThrough) {
                                    var url = this.getAttribute('data-href');
                                    window.open(url, '_blank', 'location=yes');
                                }
                            };
                            links[i].setAttribute('data-href', links[i].href)
                            links[i].removeAttribute('href');
                        }

                    }).
                    error(function (data, status, headers, config) {
                        console.log(headers);
                    });


                //window.plugins.AdMob.showInterstitialAd(true,function(){},function(e){
                //   alert(JSON.stringify(e));
                //});

            }

            function setContainerOffset(percent, animate, $element, callback, event) {

                $element.removeClass("animate");
                if (animate) {
                    $element.addClass("animate");
                }

                if (event == 'release') {
                    console.log('release');
                    console.log($element[0]);
                }

                $element[0].style.transform = "translate3d(" + percent + "%,0,0) scale3d(1,1,1)";
                $element[0].style["-webkit-transform"] = "translate3d(" + percent + "%,0,0) scale3d(1,1,1)";

                //Check and see if event listener has been set yet, and dont set listener unless its
                if (
                    ($element[0].getAttribute('data-animation-listener') == null) &&
                    (typeof event !== 'undefined' && event == 'release')
                ) {
                    //Set event listener attribute so event is only set once
                    $element[0].setAttribute('data-animation-listener', 'true');
                    console.log('callingme!');
                    setTimeout(function () {
                        animationEnd($element[0], callback)
                    }, 500);
                    //Add in our callback to our element
                    //addListener($element[0], 'transitionend', animationEnd, callback);
                }
            }

            //Do a number of things once animation is over
            function animationEnd(e, callback) {
                console.log('its over!!');
                //remove scroll lock to allow zooming and such
                container[0].classList.remove('scroll_lock');
                container[0].classList.remove('dragging_prev_page');
                container[0].classList.remove('dragging_curr_page');
                container[0].classList.remove('page_turning');
                //remove data-animation-listener
                e.removeAttribute('data-animation-listener');
                callback && callback();
                //Check for and fire callback
                //e.target[e.type+'-callback'] && e.target[e.type+'-callback']();
                //cleaning up, delete this callback
                //delete e.target[e.type+'-callback'];
                //Remove Listener
                //removeListener(e.target,'transitionend', this);
            };

            //Allows us to dyanmically set event listeners
            function addListener(e, event, func, callback) {
                //dyanmically add callback to element
                e[event + '-callback'] = callback;
                e.addEventListener(event, func, false);
            }

            //Allows us to dyanmically remove event listeners
            function removeListener(e, event, func) {
                e.removeEventListener(event, func, false);
            }


            function handleHammer(ev) {

                // disable browser scrolling
                //ev.gesture.preventDefault();
                var pageTransform = new WebKitCSSMatrix(window.getComputedStyle(container[0]).webkitTransform);


                //Only allow touch features if the page isn't scalled.
                if (pageTransform.d == 1 && !container[0].classList.contains('page_turning')) {

                    switch (ev.type) {
                        case 'tap':
                            disableAdClickThrough = false;

                            if (ev.gesture.center.pageX < (window.innerWidth * .13)) {
                                load_prev_page();
                                disableAdClickThrough = true;
                            } else if (ev.gesture.center.pageX > (window.innerWidth * .88)) {
                                load_next_page();
                                disableAdClickThrough = true;
                            } else {

                                //if this is an ad page don't open modal
                                if (!currPageIsAdPage) {
                                    $scope.openModal();
                                }
                            }

                            break;
                        case 'dragright':
                            //console.log('drag right');
                            container[0].classList.add('scroll_lock');
                            if (current_page !== 0) {

                                //Set Class to show what were dragging
                                container[0].classList.add('dragging_prev_page');

                                // stick to the finger
                                var offset = ((100 / parseInt($curr_page[0].offsetWidth, 10) ) * ev.gesture.deltaX) - 100;
                                //console.log("offset: " + offset);
                                setContainerOffset(offset, false, $prev_page);
                            }

                            break;
                        case 'dragleft':
                            //console.log('drag left');
                            container[0].classList.add('scroll_lock');

                            if (current_page !== page_total) {
                                //Set Class to show what were dragging
                                container[0].classList.add('dragging_curr_page');

                                // stick to the finger
                                var offset = ((100 / parseInt($curr_page[0].offsetWidth, 10) ) * ev.gesture.deltaX);
                                //console.log("offset: " + offset);
                                setContainerOffset(offset, false, $curr_page);
                            }
                            break;

                        case 'swipeleft':
                            //self.next();
                            //ev.gesture.stopDetect();
                            console.log('swipe left');
                            break;

                        case 'swiperight':
                            //self.prev();
                            //ev.gesture.stopDetect();
                            console.log('swipe right');
                            break;

                        case 'release':
                            console.log('release');


                            // more then 50% moved, navigate
                            if (Math.abs(ev.gesture.deltaX) > window.innerWidth / 5) {

                                if (ev.gesture.direction == 'right') {
                                    load_prev_page();
                                } else {
                                    load_next_page();
                                }
                            }
                            else {

                                // No page change has happend, so we need to check if the user
                                // is moving the current page or the previous page
                                if (container[0].classList.contains('dragging_prev_page')) {
                                    showPage('curr-prev', true);
                                } else {
                                    showPage('curr', true);
                                }
                            }
                            break;
                    }
                }
            }


            var pageGesture = ionic.onGesture("tap release drag dragleft dragright swipeleft swiperight", handleHammer, container[0], {drag_lock_to_axis: true});


            //Setting up Modal Template for review template
            $ionicModal.fromTemplateUrl('templates/review.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;
                $scope.close = $scope.closeModal();
            });

            //Modal Functions
            $scope.openModal = function () {
                //alert('close model');

                window.plugins.orientationLock.lock("portrait");
                $scope.similarSeries = '';
                comic.getSeries({id: comic.data.series.id}, function (data) {
                    //Get similar series to this one
                    comic.getSimilarSeries({id: data.series.categories[0].id}, function (data) {
                        $scope.similarSeries = data.series;
                    });
                });
                if (!$scope.isRated) { //current_page == page_total &&
                    var rating_count = 0;
                    $('.popup-overlay').fadeIn();
                    setTimeout(function(){
                        $('.popup-wrapper').fadeIn();
                        rating_count = 0;
                        $('.avg-rev-rating .star-rating i').css({'width':0+'%','opacity':1});
                        $('.star-rating input[type="radio"]').prop('checked', false);
                    },400);
                    $('.star-rating input[type="radio"]').prop('checked', false);
                    $('.star-rating input[type="radio"]').change(function(){
                        rating_count=this.value;
                    });
                    var isSubmit = false;
                    $('.rate').on('click',function(){
                        if (rating_count != undefined && rating_count != 0 && !isSubmit) {
                           //alert("Your Rating is: "+rating_count);
                            isSubmit = true;
                            // hide model
                            var params = {
                                series_id: $stateParams.sid,
                                issue_id: +$stateParams.cid,
                                user_id: user.data.id,
                                rating_value: rating_count
                            }
                            if(rating_count >= 4){
                                $('.popup-wrapper').fadeOut();
                                $('.popup-thnks-rate-wrapper').fadeIn();
                                $scope.ajaxRate(params);
                                $scope.social = {
                                    twitter: function(){
                                        window.plugins.socialsharing.shareViaTwitter(comic.data.title, comic.data.pages[0].image, 'http://www.farragocomics.com')
                                        $('.popup-thnks-rate-wrapper').fadeOut();
                                        $('.popup-overlay').fadeOut();
                                        $scope.modal.show();
                                        $('.avg-rev-rating .star-rating i').css({'width':$scope.issueRating+'%','opacity':1});
                                    },
                                    facebook:function(){
                                        window.plugins.socialsharing.shareViaFacebook(comic.data.title, comic.data.pages[0].image, 'http://www.farragocomics.com');
                                        $('.popup-thnks-rate-wrapper').fadeOut();
                                        $('.popup-overlay').fadeOut();
                                        $scope.modal.show();
                                        $('.avg-rev-rating .star-rating i').css({'width':$scope.issueRating+'%','opacity':1});
                                    }
                                }
                            }else{
                                $('.popup-wrapper').fadeOut();
                                $('.popup-overlay').fadeOut();
                                $scope.modal.show();
                                $scope.ajaxRate(params,updateRate);
                                $('.avg-rev-rating .star-rating i').css({'width':$scope.issueRating+'%','opacity':1});
                            }
                        }
                        function updateRate(){
                            $('.avg-rev-rating .star-rating i').css({'width':$scope.issueRating+'%','opacity':1});
                        }
                    });
                    $('.close_icon,.r-cancel,.msg-cancel').on('click', function () {
                        $('.popup-thnks-rate-wrapper').fadeOut();
                        $('.popup-wrapper').fadeOut();
                        $('.popup-overlay').fadeOut();
                        $('.star-rating input[type="radio"]').prop('checked', false);
                        rating_count = 0;
                        $scope.modal.show();
                        $('.avg-rev-rating .star-rating i').css({'width':$scope.issueRating+'%','opacity':1});
                    });
                } else {
                    $scope.modal.show();
                    $('.avg-rev-rating .star-rating i').css({'width':$scope.issueRating+'%','opacity':1});
                }
                $('.avg-rev-rating .star-rating i').css({'width':$scope.starRating+'%','opacity':1});
                //Set height of scroll
                (document.querySelectorAll('.review .scroll'))[0].style.height = screen.height + 'px';
            };
            $scope.ajaxRate = function(params, callback){
                $http({
                    method: 'POST',
                    url: BASEURL + 'api/ratings',
                    headers: {
                        "user-token": user.data.token,
                        "user-email": user.data.email
                    },
                    data: params
                }).
                    success(function (data, status, headers, config) {
                        $scope.isRated = true;
                        $scope.averageRating = data.averageRating;
                        $scope.totalUsers = data.totalUsers;
                        $scope.issueRating =  $scope.averageRating*20;
                        callback();
                    }).
                    error(function (data, status, headers, config) {
                        //alert(' error ');
                    });
            };
            $scope.closeModal = function (pid) {
                //alert('TODO PORTRAIT MODE');
                window.plugins.orientationLock.unlock(); // TODO PORTRAIT MODE
                if (pid) {
                    _gotoPage(pid);
                }

                $scope.modal.hide();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function () {
                //alert('close modal');
                $scope.modal.remove();

            });
            // Execute action on hide modal
            $scope.$on('modal.hidden', function () {
                // Execute action
            });
            // Execute action on remove modal
            $scope.$on('modal.removed', function () {
                // Execute action
                //alert('model removed');
            });


        }


        if (typeof comic.offline.issues[$stateParams.cid] == 'undefined') {
            //Grab the comic
            $scope.comicIsOffline = false;
            $http({
                method: 'GET',
                url: BASEURL + 'api/issues/' + $stateParams.cid,
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                }
            }).
                success(function (data, status, headers, config) {
                    comic.data = data.issues;
                    console.log(comic);
                    startbook();
                }).
                error(function (data, status, headers, config) {
                    console.log(data);
                });
        } else {
            $scope.comicIsOffline = true;
            comic.data = comic.offline.issues[$stateParams.cid];
            startbook();
        }

    });
