angular.module('farrago.controllers')
.controller('LibraryCtrl', function($scope, $ionicScrollDelegate, $ionicLoading, $http, comic, user, util) {
		
  	//Set page id
	document.body.id = 'library-view';
	
	
	
    if(typeof analytics !== "undefined") {
		analytics.trackView('Library');
	}	
	
	//Get any offline comics
	comic.getOfflineComics();
	
	$scope.openComic = function(){
		console.log(e);
	}
	
    
    //Remove this saved issue from the server
    $http({
        method: 'GET', 
        url: BASEURL + 'api/saved_issues',
        headers:{
            "user-token":user.data.token,
            "user-email":user.data.email
        }
     }).success(function(data, status, headers, config) {
    
    });
      
					

	
	//Touch handler for various page functions
	var handleTap = function(e){
		console.log(e);
		e.preventDefault();
		if(e.srcElement.nodeName == "IMG"){
			comicOpen(e);
		}else if(e.srcElement.classList.contains('remove-from-offline') || e.srcElement.classList.contains('save-for-offline') ){
			var issueId = e.srcElement.parentElement.parentElement.getAttribute('data-issue-id');
	  		toggleOffline(e);
		}else if(e.srcElement.classList.contains('remove-from-favorites')){
			var issueId = e.srcElement.parentElement.parentElement.getAttribute('data-issue-id');
			removeFromFavorites(e); 
		}else if($fav_menu){
			//remove menu element
			$fav_menu.remove();
			$fav_menu = false;
		}
	}
	var pageTap = ionic.onGesture("tap", handleTap, document.querySelector('#library'), { drag_lock_to_axis: true });
		 
	//If connected to the internet
	if(util.online){

		//Grab the users favorites
		$http({
			method: 'GET', 
			url: BASEURL + 'api/favorites',
			headers:{
				"user-token":user.data.token,
				"user-email":user.data.email
			}
		 }).
			success(function(data, status, headers, config) {
				console.log(data);
				$scope.total = data.issues.length;
				var total_offline = Object.keys(comic.offline.issues).length;
				$scope.total_offline = (typeof total_offline === 'number')? total_offline: 0;
			
				var row_1 = [];
				var row_2 = [];
				for(var i=0,j=data.issues.length;i<j;i++){
		
					//Any comics that have been saved for offline tag them with class
					data.issues[i].offline = (comic.offline.issues[data.issues[i].id])? "offline ion-checkmark-circled":'';
					row_1.push(data.issues[i]);
					//Grab the first half of issues
					//if(i<j/2 || j < 4){
					//	row_1.push(data[i]);
					//Grab the second half	
					//}else{
					//	row_2.push(data[i]);
					//}
                    $ionicLoading.hide();

				} 
				$scope.row_1 = row_1;
				//$scope.row_2 = row_2;
		
			}).
		error(function(data, status, headers, config) {
			console.log(data);
            $ionicLoading.hide();
		});
	
	//Grab images from local storage
	}else{

	
		$scope.total = 0;
		$scope.total_offline = 0;
	
		//Get array of properties
		if(typeof comic.offline.issues == 'object'){
			var issues = Object.keys(comic.offline.issues);
 			$scope.total = issues.length;
			var total_offline = Object.keys(comic.offline.issues).length;
			$scope.total_offline = (typeof total_offline === 'number')? total_offline: 0;
			
			var row_1 = [];
			var row_2 = [];
			for(issue in comic.offline.issues){
 				row_1.push({id:issue, thumb_url:comic.offline.issues[issue].pages[0].image_large_url, offline: "offline ion-checkmark-circled"});
			} 
	
			$scope.row_1 = row_1;			
		}else{
			$scope.total = 0;
			$scope.total_offline = 0;
		}
        
        $ionicLoading.hide();
	}
	 
	//Create loading element  
	var loading = document.createElement('div');
	loading.classList.add('spinner');
	
	var status = document.createElement('span');
	status.classList.add('status');
	

	var $fav_menu = false;
	$scope.showMenu = function(issueId){
		
		var item = document.querySelector("#issue_"+issueId);
	
		var menu = document.createElement('ul');
			menu.classList.add('fav-menu');
		var li_fav = document.createElement('li');
			li_fav.classList.add('remove-from-favorites');
			li_fav.innerHTML = 'Remove from favorites';
			li_fav.onclick = removeFromFavorites;
		var li_offline = document.createElement('li');
				
		//If saved to offline
		if(item.classList.contains('offline')){
			li_offline.innerHTML = 'Remove from offline';
			li_offline.classList.add('remove-from-offline');
			li_offline.onclick = toggleOffline;
		//Save to offline
		}else{
			li_offline.innerHTML = 'Save for offline reading';
			li_offline.classList.add('save-for-offline');
			li_offline.onclick = toggleOffline;
		}
		
		menu.appendChild(li_fav);
		menu.appendChild(li_offline);
		item.appendChild(menu);
		
		$fav_menu = angular.element(document.querySelector("#issue_"+issueId + ' .fav-menu'));
		
	}
	
	var removeFromFavorites = function(e){
		
		if($fav_menu){
			var issueId = e.srcElement.parentElement.parentElement.getAttribute('data-issue-id');
					
			//remove menu element
			$fav_menu.remove();
			$fav_menu = false;
		
			//remove from favorites
			comic.removeFromFavorites(issueId);
		
		
			//offline issue exists, remove
			var offline = comic.getOfflineComics();	
			if(typeof comic.offline.issues[issueId] !== 'undefined'){	
				_removeFromOffline(issueId);		
			//offline issue doesn't exist, add it.	
			}
		
			//Remove item from layout
			angular.element(document.querySelector("#issue_"+issueId)).remove();
		}
		
	}
	
	//Alias to comic.open 
	var comicOpen = function(e){
		
		//prevent extra clicks
		if(e.srcElement.nodeName == "IMG"){
			var issueId = e.srcElement.parentElement.getAttribute('data-issue-id');
				
			if(typeof $fav_menu !== 'object'){
				comic.open(issueId);
			}else{
				//remove fav menu element
				$fav_menu.remove();
				$fav_menu = false;
			}
		}
	}
	$scope.comicOpen = comicOpen;
	
	var toggleOffline = function(e){
		
		//prevent extra clicks
		if($fav_menu){
			var issueId = e.srcElement.parentElement.parentElement.getAttribute('data-issue-id');
				
			//remove menu element	
			$fav_menu.remove();
			$fav_menu = false;
					
			console.log(issueId);
			var offline = comic.getOfflineComics();	
			
			//offline issue exists, remove
			if(typeof offline.issues[issueId] !== 'undefined'){	
				_removeFromOffline(issueId);		
			//offline issue doesn't exist, add it.	
			}else{
				_saveForOffline(issueId);
			}
		}
	}
	
	//Remove comic from local offline storage
	var _removeFromOffline = function(issueId){
		comic.removeFromOffline(issueId);
		document.querySelector("#issue_"+issueId).classList.remove('offline');
		document.querySelector("#issue_"+issueId).classList.remove('ion-checkmark-circled');	
	}
	
	//Save comic to offline storage
	var _saveForOffline = function(id){
	 
		document.getElementById("issue_"+id).appendChild( loading );
		document.getElementById("issue_"+id).appendChild( status );
		
		//listen for saving event
		var _saveListener = $scope.$on(''+id, function(e,r){
			
			//Set status on element
			document.querySelector("#issue_"+id+" .status").innerHTML = r.status;
			$scope.total_offline = Object.keys(comic.offline.issues).length;

			//Remove uneeded elements once complete
			if(r.complete){
				$("#issue_"+id+" .spinner").remove();
				$("#issue_"+id+" .status").remove();
				$("#issue_"+id).addClass('offline');
				$("#issue_"+id).addClass('ion-checkmark-circled');
				_removeListener();
			}
			
		});   
		
		//Calling the set listner which removes it
		var _removeListener = function(){
			_saveListener();
		}
  
		comic.saveForOffline(id);
	}
	  
	  
	  
	//Check connection, and load comics
	util.checkConnection();  
	 		  		
});