angular.module('farrago')
.controller('LoginCtrl', function($scope, $ionicLoading, $ionicScrollDelegate, util, $http, user, $state, $ionicPopup, $stateParams, $ionicPlatform, $ionicSlideBoxDelegate) {

  
    util.checkConnection();
    //If they've already signed up for some reason, go to featured page 
    if(util.online && user.data.token){
        $state.go('tab.featured');
    }
	
	//window.plugins.orientationLock.lock("landscape");
  
  	//Set page id
	document.body.id = 'login-view';	
	
  	$scope.signupForm = {};
	$scope.signupFields = {};
    
    $ionicLoading.hide();
  
    if(typeof analytics !== "undefined") {
		analytics.trackView('Login');
	}

	//Provid ability to move to next slide	
    $scope.nextSlide = function() {
	  var fields = validateSlide1();
	  if(fields){
	  		$ionicSlideBoxDelegate.next();
	  }
    }
	
	
	//Wait until things are are ready
	  ionic.DomUtil.ready(function() {  
		  
  		//Fill out age field
  	    var age_field = document.querySelectorAll('.no-login .age')[0];
  	  	for(var i=8;i<100;i++){
  	  		var option = document.createElement('option');
  	  		option.innerHTML = i;
  	  		option.setAttribute('value',i);
  	  	 	age_field.appendChild(option);
  	  	}		 
		  
		//Show the fff id box if they were reffered by a friend
		document.querySelector('.item-checkbox.fff').addEventListener('click', _showFFF);
		function _showFFF(e){
			var fff_id = document.querySelector('.fff-id');
			if(fff_id.style.display == "none"){
				fff_id.style.display = "block";
			}else{
				fff_id.style.display = "none";
			}
		}
				
	  });

		
	//Fill out user info
	if(typeof $stateParams.type !== undefined && $stateParams.type === "true"){	
		document.querySelectorAll('.no-login .age')[0].value = user.data.age;
		document.querySelectorAll('.no-login .gender')[0].value = user.data.gender;
		document.querySelectorAll('.no-login .audience')[0].value = user.data.audience;
		$scope.submitButtonText = 'Update My Account';
	}else{
		
		$scope.submitButtonText = 'View Comics';
	}
	
	//Submit User Data
	$scope.submitData = function(){
			signup();	
	}
	
	//Sign up a temp user, and get sessionid
	var signup = function(){

       /* var fields = validateSlide1();
        if(fields){*/
			//Signup temp user
			user.signup(function(r){
              
                submitSurvey();
				if(r.status === "signedUp"){				
					$state.go('tab.featured');
				}
              
			});					
		/*}*/
	}
	

	function _getInputValue(name){
		var	inputs = document.getElementsByName(name);
		var data = [];
		for (var i = 0, length = inputs.length; i < length; i++) {
		    if (inputs[i].checked) {
				//Check for checkbox
				if(inputs[i].type === "checkbox"){
		        	// grab value from the checkbox
	        		data.push(inputs[i].value);
				}else{
		        	return inputs[i].value;
			        // only one radio can be logically checked, don't check the rest					
					break;	
				}
		    }
			//Last item, return some stuff
			if(inputs[i].type === "checkbox" && i+1 === length){
				return data;
				break;	
			}
		}		
	}
	
	//Set Temp User
	var tempUser = {};
	
	//Validate form fields
	var validateSlide1 = function(){
				
		var validationErrors = [];
		tempUser.age = document.querySelector('.no-login .age').value;
		tempUser.gender = _getInputValue('gender');
		tempUser.audience = _getInputValue('audience');
							
		//Check if age is filled out
		if( tempUser.age === '' || isNaN(tempUser.age) ){			
			validationErrors.push( document.querySelector('.no-login .age') );
		}
		
		//Check if gender is filled out
		if( tempUser.gender === '' || typeof tempUser.gender === 'undefined' ){			
			validationErrors.push( document.querySelector('.no-login .gender .item') );
		}
		
		//Check if audience is filled out
		if( tempUser.audience === '' || typeof tempUser.audience === 'undefined'){			
			validationErrors.push( document.querySelector('.no-login .audience .item') );
		}
				
				
		//Check if anything didn't validate
		if(validationErrors.length > 0){
			
			for(i=0, j=validationErrors.length; i<j;  i++){
				validationErrors[i].parentNode.classList.add('error');
			}
						
			return false;	
		}else{
			
			//save some user data		
			user.data.age = tempUser.age;
			user.data.gender = tempUser.gender;
			user.data.audience = tempUser.audience;
					
			return true;
		}
			
	}
	
	var validateSlide2 = function(){
		
		var validationErrors = [];
		//Optional Fields, get data if there is any
		tempUser.email = document.querySelector('.email-container input').value;
		tempUser.firstname = document.querySelector('.first-name-container input').value;
		tempUser.password = document.querySelector('.pass-container input').value;
		tempUser.hear = document.querySelector('.hear-container .hear').value;
		tempUser.whydownload = _getInputValue('whydownload');
		tempUser.fffid = document.querySelector('.whydownload-container .fff-id input').value;
		
		
		function _validateEmail(email) { 
		    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		    return re.test(email);
		} 
		
		//If they entered email, check if its filled out properly
		if( tempUser.email !== '' && !_validateEmail(tempUser.email) ){			
			validationErrors.push( document.querySelector('.no-login .email-container input') );
		}
		
		//If they entered an fffid, check if its filled out properly
		if( tempUser.fffid !== '' && isNaN(tempUser.fffid)){			
			validationErrors.push( document.querySelector('.whydownload-container .fff-id input') );
		}
		
		//Check if anything didn't validate
		if(validationErrors.length > 0){		
			for(i=0, j=validationErrors.length; i<j;  i++){
				validationErrors[i].parentNode.classList.add('error');
			}
						
			return false;	
		}else{	
                    
			//Save some basic stats
			var stats = {};
			stats.hear = tempUser.hear;
			stats.whydownload = tempUser.whydownload;
			stats.fffid = tempUser.fffid;
			storage.set('stats', stats);
			
			//if we have both email and password remove temp action
			if(tempUser.email !== '' && tempUser.password !== ''){
				storage.set('temp', false);
				user.data.status = "authenticated";
			}		
			
			//Set email and pass
			if(tempUser.email !== ''){
				user.data.email = tempUser.email;
              
              //Only allow password set if you put in email
              if(tempUser.password !== ''){
                  user.data.password = tempUser.password;
                  user.data.password_confirmation = tempUser.password;
              }	
              
			}
			


			return true;
		}
		
	}
    
    var submitSurvey = function(){
		//alert(' click');
            var surveyResponse = {
            survey_response:{
              survey_id:1,
              survey_answers:[
                {
                  survey_question_id: 1,
                  content:tempUser.hear
                },
                {
                  survey_question_id: 2,
                  /*content:tempUser.whydownload.toString()*/
                },
                {
                  survey_question_id: 3,
                  content:tempUser.fffid
                }
              ]
          }}
		  

		  
		  // POST CALL FOR SAVING USER ISSUE RATING
		  

		  
		  // POST CALL FOR SURVEY RESPONSE
          
         /* $http({
			method: 'POST', 
			url: BASEURL + 'api/survey_responses',
			headers:{
				"user-token":user.data.token,
				"user-email":user.data.email
			},
            data: surveyResponse
		 }).
		  success(function(data, status, headers, config) {
              
		  }).
		  error(function(data, status, headers, config) {
            
		  });*/
    };
	
	
});