angular.module('farrago.controllers')
.controller('SearchCtrl', function($scope, $ionicScrollDelegate, $http, comic, user, $ionicModal) {
	
  	//Set page id
	document.body.id = 'search-view';
	
	$scope.results = 0;
	$scope.comic = comic;
	$scope.user = user;
	$scope.search = function(){
		console.log($scope.userInput);
		searchComics($scope.userInput);
	}
    
    if(typeof analytics !== "undefined") {
		analytics.trackView('Search');
	}	
		
	var searchComics = function(terms){

		if(terms !== ''){
			$http({
				method: 'GET', 
				url: BASEURL + 'api/series',
				params: {keyword:terms},
                headers:{
                  "user-token":user.data.token,
                  "user-email":user.data.email
                }
			 }).
			  success(function(data, status, headers, config) {
				  $scope.comics = data.series;  
				  $scope.search_total = data.series.length;  
			  }).
			  error(function(data, status, headers, config) {
			     console.log(data);
			  });
	  }
	}
	
	//Get Series Details and Popup modal
	$scope.showDetails = function(id){
      if(typeof $scope.comics !== 'undefined'){
          $scope.series = '';
          $scope.similarSeries = '';
          for(var x=0,y=$scope.comics.length; x<y;x++){
            if($scope.comics[x].id === id){
                $scope.series = $scope.comics[x];		  	
            }
          }
        
          //No series data found locally, then grab from server
          if($scope.series === ''){
            comic.getSeries({id:id}, function(data){
              $scope.series = data.series;     
                //Get similar series to this one
                comic.getSimilarSeries({id:$scope.series.categories[0].id}, function(data){
                  $scope.similarSeries = data.series;
                });
              
            });
          }else{
              //Get similar series to this one
              comic.getSimilarSeries({id:$scope.series.categories[0].id}, function(data){
                $scope.similarSeries = data.series;
              });
          
          }

        
          //Show the modal
          $scope.modal.show();	
          //Add all issues issue to favorites
          $scope.addSeriesToFavorites = function(){
              comic.addToFavorites($scope.series.issues);
          }
          //Add one issue to favorite
          $scope.addToFavorites = function(issueId){
              comic.addToFavorites(issueId);
          }	
                
      }
	};
	  	
	//Setting up Modal Template for Details
	$ionicModal.fromTemplateUrl('templates/details.html', {
	  scope: $scope
	}).then(function(modal) {
		console.log(modal);
	  $scope.modal = modal;
	  $scope.closeModal();
	});
	  
	//Modal Functions
	$scope.openModal = function() {
	  $scope.modal.show();
	};
	$scope.closeModal = function() {
	  $scope.modal.hide();
	};
	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
	  $scope.modal.remove();
	});
	// Execute action on hide modal
	$scope.$on('modal.hidden', function() {
	  // Execute action
	});
	// Execute action on remove modal
	$scope.$on('modal.removed', function() {
	  // Execute action
	});
	
});