angular.module('farrago')
.controller('SeriesCtrl', function($scope, $ionicLoading, $ionicScrollDelegate, $http, $ionicModal, user, comic, $stateParams, util) {
    
	  
	//Check connection, and load comics
	util.checkConnection();  
  
	$scope.showLeft = function () {
      $ionicSideMenuDelegate.toggleLeft();
    };
    
    //Sync any offline comics
    comic.getOfflineComics();
  
    //If the user is offline hide loading bar
    if(!util.online){
        //Hide Loading spinner 
        document.querySelector('.spinner').classList.remove('show');
    }
  
  	//Set page id
	document.body.id = 'series-view';
	$scope.initialized = false;	
	$scope.user = user.user;
	$scope.comic = comic;
	$scope.categories = {};
  
	//Run check to login the user if there is a connection to internet
	//user.loginExisting();
	
	//Initialize Primary Controller Functions
	var initController = function(){
		/*
		console.log('genres');
		var mydata = user.data;
		console.log(mydata);
		*/
        comic.getCategories(function(){

          $scope.initialized = true;
          //Set user categories
          if(typeof user.categories == 'undefined'){
            user.categories = comic.categories;
          }
            //update the categories to have user selections in them
            for(var i=0,j=user.categories.length; i<j;i++){
              //for each user selected item, map the selection to the latest category array from server
              for(var x=0,y=comic.categories.length; x<y;x++){
                if(comic.categories[x].id === user.categories[i].id){
                  comic.categories[x].selected = user.categories[i].selected;
                }
              }    
            }


          $scope.categories = comic.categories;
          getSeries();   

          if(typeof analytics !== "undefined") {
              analytics.trackView('Series');
          }
          
        });

	}
	
  
	var getSeries = function(){
		$http({
			method: 'GET', 
			url: BASEURL + 'api/series',
			headers:{
				"user-token":user.data.token,
				"user-email":user.data.email
			},
            params: {category: user.urlCategoryList(), page:1}
		 }).
		  success(function(data, status, headers, config) {
			  $scope.comics = data.series;  
              $scope.total = (data.series.length > 0 )? data.series[0].query_count: 0;
              $scope.offlineIssueCount = {};
          
              //Grab all offline isssues
              if(Object.keys(comic.offline.issues).length > 0){
                for(var issue in comic.offline.issues){
                    //If this already exists
                    if($scope.offlineIssueCount[ comic.offline.issues[issue].series.id ]){
                      $scope.offlineIssueCount[ comic.offline.issues[issue].series.id ]++;
                     //Does exsist
                    }else{
                      $scope.offlineIssueCount[ comic.offline.issues[issue].series.id ] = 1;
                    }     
                }
              }
          
			  $scope.comicSelected = 0;
              
              //Hide Loading spinner 
              document.querySelector('.spinner').classList.remove('show');
		  }).
		  error(function(data, status, headers, config) {
		     console.log(data);
              //Hide Loading spinner 
              document.querySelector('.spinner').classList.remove('show');
		  });
	}
    
    //Set item width based on screen size
    $scope.getComicItemWidth = function(){
        return (window.innerWidth > 500)? '50%': '100%';
    };
        
    //load more series and display it to the user.
    $scope.loadMorePage = 2;
    $scope.loadSeriesCheck = true;
    $scope.loadMoreSeries = function(){
      if(typeof $scope.comics !== "undefined" && $scope.comics !== ""){
      //show Loading spinner 
      document.querySelector('.spinner').classList.add('show');
      
      $http({
          method: 'GET', 
          url: BASEURL + 'api/series',
          headers:{
              "user-token":user.data.token,
              "user-email":user.data.email
          },
          params: {category: user.urlCategoryList(), page:$scope.loadMorePage}
       }).
        success(function(data, status, headers, config) {
        
          if(data.series.length > 0){
            $scope.loadMorePage++;
            //Merge new comics into array
            $scope.comics = $scope.comics.concat(data.series);
            $scope.comicSelected = 0; 
          }else{
            $scope.loadSeriesCheck = false;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
          //Hide Loading spinner 
          document.querySelector('.spinner').classList.remove('show');
        }).
        error(function(data, status, headers, config) {
          //Hide Loading spinner 
          document.querySelector('.spinner').classList.remove('show');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });

      }else{
          $scope.$broadcast('scroll.infiniteScrollComplete');
      }
      
      
     }
    
	
		
	$scope.toggleFilters = function(){
		var filtersBtn = document.querySelector('#series #filter-btn');
		var filters = document.querySelector('#series .filters');
		filtersBtn.classList.toggle('show-filters');
		filters.classList.toggle('show-filters');
		
		$scope.updateCategories = function(){
			var updatedCategoryInputs = document.querySelectorAll('#series .filters .checkbox input');
			var updatedCategories = [];
			
            $scope.loadMorePage = 2;
            $scope.loadSeriesCheck = true;
          
			for(var i=0, j=updatedCategoryInputs.length; i<j ;i++){
				updatedCategories.push({
					'id':+updatedCategoryInputs[i].value,
					'selected':""+updatedCategoryInputs[i].checked,
					'name':updatedCategoryInputs[i].name,
                    '_link':updatedCategoryInputs[i].getAttribute('data-link'),
                    'series_count':updatedCategoryInputs[i].getAttribute('data-series-count')
				});
			}			
			//Save categories locally
			storage.set('category_preferences', updatedCategories);
			user.categories = updatedCategories;
			$scope.comics = [];
			getSeries();	
		}
		
	}	
	

    
	//Get Series Details and Popup modal
	$scope.showDetails = function(id, num){
          //Get element and snag series id, because angular/ionic doesn't want to pass it in through the function.
          if(!id){
            var id = (document.querySelector('#series .listy .item-num-'+num)).getAttribute('data-comic-id');
          }
        $http({
            method: 'GET',
            url: BASEURL + 'api/ratings/'+id,
            headers:{
                "user-token":user.data.token,
                "user-email":user.data.email
            }
        }).
            success(function(data, status, headers, config) {
                $scope.seriesAverageRating = data.avgRating;
                $scope.seriesTotalUsers = data.totalUsers;
                var rate_per = $scope.seriesAverageRating*20;
                $('.avg-rating .star-rating i').css({'width':rate_per+'%','opacity':1});
            }).
            error(function(data, status, headers, config) {
                //alert('error');
            });
          //Reset some things
          $scope.series = '';
          $scope.similarSeries = '';

          if(typeof $scope.comics !== 'undefined'){
            for(var x=0,y=$scope.comics.length; x<y;x++){
              if($scope.comics[x].id === id){
                  $scope.series = $scope.comics[x];
              }
            }
          }
          //No series data found locally, then grab from server
          if($scope.series === ''){
            comic.getSeries({id:id}, function(data){
              $scope.series = data.series;
                //Get similar series to this one
                comic.getSimilarSeries({id:$scope.series.categories[0].id}, function(data){
                  $scope.similarSeries = data.series;
                });

            });
          }else{
              //Get similar series to this one
              comic.getSimilarSeries({id:$scope.series.categories[0].id}, function(data){
                $scope.similarSeries = data.series;
              });

          }


          //Show the modal
          $scope.modal.show();
        $scope.seriesId = id;
          //Add all issues issue to favorites
          $scope.addSeriesToFavorites = function(){
              comic.addToFavorites($scope.series.issues);
          }
          //Add one issue to favorite
          $scope.addToFavorites = function(issueId){
              comic.addToFavorites(issueId);
          }

	};
	  	
	//Setting up Modal Template for Details
	$ionicModal.fromTemplateUrl('templates/details.html', {
	  scope: $scope
	}).then(function(modal) {
	  $scope.modal = modal;
      
        //If issue Id is set, bring up modal with details
		if(typeof $stateParams.iid === 'string' && $stateParams.iid !== ''){
			$scope.showDetails(+$stateParams.iid);
		}  

	});
	  
	//Modal Functions
	$scope.openModal = function() {
	  $scope.modal.show();
	};
	$scope.closeModal = function() {
	  $scope.modal.hide();
	};
	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
	  $scope.modal.remove();
	});
	// Execute action on hide modal
	$scope.$on('modal.hidden', function() {
	  // Execute action
	});
	// Execute action on remove modal
	$scope.$on('modal.removed', function() {
	  // Execute action
	});

	

	//If session is not defined await user intialize broadcast to start controller
	if(comic.initialized){
		initController();
	}else{
		$scope.$on('comicInitialized', initController);
	}	

  
});

