//Creating Local Storage JSON Interface
window.storage = {
    store: localStorage,
    get: function (key) {
        try {
            return JSON.parse(this.store[key]);
        } catch (e) {
        }
        ;
        return undefined;
    },
    set: function (key, value) {
        try {
            this.store[key] = JSON.stringify(value);
        } catch (e) {
        }
        ;
    }
}

angular.module('farrago.services', [])
    .factory('user', function ($rootScope, $http, $ionicPopup, $ionicLoading, $state, util) {
        'use strict';
        var module = {};
        module.data = {};
        module.initialized = false;
        module.init = function (callback) {

            //Wipe local session data tempporarillyyyyyyyyy
            //#########################
            //#########################
            //#######################
            //#########################
            //#########################
            //  storage.set('user', '');
            //storage.set('user', {email:" jticj6fbpqggmn@nosignup.com", password:"temptemptemp"});
            //storage.set('user', {email:" wooter10@wootergmail.com", token:"t8AvzfUaHFTsUCKp-R73"});


            //Check for exisiting User data, else set our own
            if (storage.get('user') !== undefined && storage.get('user') !== '') {
                module.data = storage.get('user');

                //Get Local category Prefs
                if (storage.get('category_preferences') !== undefined && storage.get('category_preferences') !== '') {
                    module.categories = storage.get('category_preferences');
                }

                //If user data exsits but needs session, go grab new session
                if (typeof module.data.token === "undefined") {
                    module.login(module.data, callback);
                } else {
                    callback && callback();
                }

            } else {
                //Create a random unique email/user account
                var randUser = (Math.random().toString(36) + '00000000000000000').slice(2, 16);

                //Create Empty Category prefrences
                module.category_preferences = {};

                //Setting Default user data
                //module.data.id = 0;
                module.data.email = randUser + '@nosignup.com';
                module.data.password = 'temptemptemp';
                module.data.password_confirmation = 'temptemptemp';
                module.data.audience = "18 PLUS";
                module.data.status = "guest";
                module.data.gender = "MALE";
                module.data.first_name = "";
                module.data.last_name = "";
                module.data.birthday = "1969/01/01";

                callback && callback();
            }
            return true;

        }

        module.loginExisting = function () {
            //Check for exisiting User data and login, else set our own
            if (util.online && !module.data.token && storage.get('user') !== undefined && storage.get('user') !== '') {
                module.data = storage.get('user');
                module.login();
            }
        }

        module.signup = function (callback) {

            var url = BASEURL + 'api/users';
            var userdata = {user: module.data}

            //Signup the user
            $http({
                method: 'post',
                url: url,
                data: userdata
            }).
                success(function (data, status, headers, config) {

                    //If this is a registered account, remove password locally
                    if (module.data.status == "registered") {
                        delete module.data.password;
                    }
                    //Save token data
                    module.data.token = data.token;
                    module.data.id = data.id;

                    //Save data locally
                    storage.set('user', module.data);
                    callback && callback({status: "signedUp"});


                }).
                error(function (data, status, headers, config) {
                    var alertPopup = $ionicPopup.alert({
                        title: 'Hmm...There seams to be an issue communicating with our servers.',
                        template: 'Please check your connection. '
                    });
                    $ionicLoading.hide();
                    callback && callback({status: "signupError"});
                });
        }

        module.login = function (p, callback) {

            var url = BASEURL + 'api/sessions';
            var data = {
                'user': {
                    password: p.password,
                    email: p.email
                }
            };

            //Signin the user
            $http({
                method: 'POST',
                url: url,
                data: data
            }).
                success(function (data, status, headers, config) {

                    //Save session, save it locally
                    module.data.token = data.token;

                    //Set User id
                    if (typeof analytics !== "undefined") {
                        analytics.setUserId(data.id);
                    }

                    storage.set('user', module.data);
                    callback && callback({status: "signedIn"});

                }).
                error(function (data, status, headers, config) {
                    callback && callback({status: "signInError"});
                });


            //Return session id if user already logged in
            //callback && callback({status:module.data.sessionId});


        }
        module.logout = function () {

        }
        module.update = function (p, callback) {
            //update user account

            var url = BASEURL + 'api/user';
            var data = {user: p}

            //Signup the user
            $http({
                method: 'PUT',
                url: url,
                headers: {
                    "user-token": module.data.token,
                    "user-email": module.data.email
                },
                data: data
            }).
                success(function (data, status, headers, config) {
                    //Sync Information locally
                    data.user.token = module.data.token;
                    module.data = data.user;
                    storage.set('user', module.data);

                    //Fire Any Callbacks
                    callback && callback({status: "userUpdated"});
                }).
                error(function (data, status, headers, config) {
                    callback && callback({status: "updateError"});
                });


        }
        //Gets the user categories selected by the user
        module.urlCategoryList = function () {

            var tempList = [];
            if (typeof module.categories !== 'undefined' && module.categories.length > 0) {
                for (var i = 0, j = module.categories.length; i < j; i++) {
                    if (module.categories[i].selected !== "false") {
                        tempList.push(module.categories[i].id);
                    }
                }
            }
            return tempList.toString();
        }


        //Initialzie User Account
        module.init(function (r) {
            //User logged in
            $rootScope.$broadcast('userInitialized');
        });


        return module;
    })
    .factory('comic', function ($rootScope, $http, $state, $ionicPlatform, user) {
        'use strict';
        var module = {};
        module.offline = {};

        //Init offline comic Storage
        if (typeof storage.get('offline') !== "object") {
            storage.set('offline', {issues: {}});
        }

        module.init = function (callback) {
            //get current categories
            module.getCategories(callback);
        };

        module.getOfflineComics = function () {
            module.offline = storage.get('offline');
            return storage.get('offline');
        }
        module.offlineSync = function () {
            storage.set('offline', module.offline);
        }

        module.open = function (cid, sid, pid) {
            if (!pid) {
                pid = 0;
            }
            //Open Comic Book
            $state.go('tab.comic', {cid: cid, pid: pid, sid: sid});
        }
        module.close = function (id) {
        }
        module.addToFavorites = function (issue) {

            //If its not a number, we expect an array
            if (isNaN(issue)) {

                for (var i = 0, j = issue.length; i < j; i++) {

                    //Send the request
                    $http({
                        method: 'POST',
                        url: BASEURL + 'api/favorites',
                        headers: {
                            "user-token": user.data.token,
                            "user-email": user.data.email
                        },
                        data: {issue_id: issue[i].id}
                    }).
                        success(function (data, status, headers, config) {
                        }).
                        error(function (data, status, headers, config) {
                        });
                }

                //Just Add one Comic, expecting a number
            } else {

                //Send the request
                $http({
                    method: 'POST',
                    url: BASEURL + 'api/favorites',
                    headers: {
                        "user-token": user.data.token,
                        "user-email": user.data.email
                    },
                    data: {issue_id: issue}
                }).
                    success(function (data, status, headers, config) {
                    }).
                    error(function (data, status, headers, config) {
                    });

            }

        }

        //Remove an issue from favorites
        module.removeFromFavorites = function (issueId) {

            //Send the request
            $http({
                method: 'DELETE',
                url: BASEURL + 'api/favorites',
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                },
                params: {issue_id: issueId}
            }).
                success(function (data, status, headers, config) {
                }).
                error(function (data, status, headers, config) {
                });

        }
        module.getSeries = function (p, callback) {
            $http({
                method: 'GET',
                url: BASEURL + 'api/series/' + p.id,
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                }
            }).
                success(function (data, status, headers, config) {
                    callback && callback(data);
                }).
                error(function (data, status, headers, config) {
                    callback && callback(data);
                });
        }
        module.getSimilarSeries = function (p, callback) {
            $http({
                method: 'GET',
                url: BASEURL + 'api/series',
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                },
                params: {category: p.id}
            }).
                success(function (data, status, headers, config) {
                    callback && callback(data);
                }).
                error(function (data, status, headers, config) {
                    callback && callback(data);
                });
        }
        module.getCategories = function (callback) {
            var url = BASEURL + 'api/categories';
            //Get Genres for user
            $http({
                method: 'GET',
                url: url,
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                },
            }).
                success(function (data, status, headers, config) {
                    module.categories = data.categories;

                    //Add a category selected option
                    for (var i = 0; i < module.categories.length; i++) {
                        module.categories[i].selected = true;
                    }

                    //Fire Any Callbacks
                    callback && callback({status: "genreSuccess", data: data});
                }).
                error(function (data, status, headers, config) {
                    callback && callback({status: "genreError"});
                });
        }
        //Save a book for offline reading
        module.saveForOffline = function (issueId) {

            //Sync any offline comics, to local variable
            module.getOfflineComics();

            //Grab the comic
            $http({
                method: 'GET',
                url: BASEURL + 'api/issues/' + issueId,
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                }
            }).
                success(function (data, status, headers, config) {

                    //Post this saved issue to the server
                    $http({
                        method: 'POST',
                        url: BASEURL + 'api/saved_issues',
                        headers: {
                            "user-token": user.data.token,
                            "user-email": user.data.email
                        },
                        params: {issue_id: issueId}
                    }).success(function (data, status, headers, config) {
                    });

                    //Save data from server to local object
                    module.offline.issues[data.issues.id] = JSON.parse(JSON.stringify(data.issues));
                    module.offline.issues[data.issues.id].pages = [];

                    //Make sure data is synced to offline database
                    module.offlineSync();

                    var currentPage = 0;
                    var comicLength = data.issues.pages.length;

                    function _saveOnePage() {

                        $rootScope.$broadcast('' + data.issues.id, {status: 'Saving Page ' + (currentPage) + ' of ' + comicLength, complete: false });

                        module.savePage({
                            series: data.issues.series.title,
                            issue: "" + data.issues.id,
                            page: data.issues.pages[currentPage].id,
                            url: data.issues.pages[currentPage].image_large_url

                            //callback to load next page
                        }, function (r) {
                            if (r && currentPage < comicLength) {
                                _saveOnePage();
                                currentPage++;

                                //Send out complete beacon
                            } else {
                                $rootScope.$broadcast('' + data.issues.id, {status: 'Save Completed', complete: true});
                            }
                        });
                    }

                    //Start the process to save all the pages.
                    _saveOnePage();
                    currentPage++;


                }).
                error(function (data, status, headers, config) {
                });


        }

        //Remove an issue from local storage
        module.removeFromOffline = function (issueId) {

            //Get extension, just to make sure were using the right format
            var appDir = cordova.file.applicationStorageDirectory + "files/" + issueId + '/';

            //Remove issue id from object
            delete module.offline.issues[issueId];

            //Make sure data is synced to offline database
            module.offlineSync();

            //Remove issue from file system
            var _removeIssue = function (dir) {
                var id = issueId;
                dir.removeRecursively(function () {
                    console.log('Directory removed.');
                }, _fileIO.error);
            }

            //resolve the app directory, and start removing from filesystem
            window.resolveLocalFileSystemURL(appDir, _removeIssue, _fileIO.error);

            //Remove this saved issue from the server
            $http({
                method: 'DELETE',
                url: BASEURL + 'api/saved_issues',
                headers: {
                    "user-token": user.data.token,
                    "user-email": user.data.email
                },
                params: {issue_id: issueId}
            }).success(function (data, status, headers, config) {
            });


        }

        module.savePage = function (img, callback) {

            //Get extension, just to make sure were using the right format
            var ext = "." + img.url.split('.').pop();
            var appDir = cordova.file.applicationStorageDirectory + "files/";

            //Create series folder
            //var _createSeries = function(dir){
            //   dir.getDirectory(''+img.series, {create: true}, _createIssue, _fileIO.error);
            //}

            //create issue folder
            var _createIssue = function (dir) {
                dir.getDirectory(img.issue, {create: true}, _saveImage, _fileIO.error);
            }

            var _saveImage = function (dir) {

                // Set success and error callbacks when handling image
                var write_success = function (cached_url) {

                    var offline = storage.get('offline');

                    module.offline.issues[img.issue].pages.push({id: img.issue, image_large_url: cached_url});
                    module.offlineSync();

                    console.log('download ok: ' + cached_url);
                    callback && callback(true);
                };

                var failCallback = function () {
                    console.log('download failed');
                };

                //Open new xhr request
                var xhr = new XMLHttpRequest();
                xhr.open('GET', img.url, true);
                xhr.responseType = 'arraybuffer';
                xhr.addEventListener('load', function () {

                    //Start writing the file from response
                    dir.getFile(img.page + ext, {create: true, exclusive: false}, function (fileEntry) {

                        fileEntry.createWriter(function (writer) {

                            writer.onwrite = function (e) {
                                write_success(fileEntry.toURL());
                            };

                            writer.onerror = failCallback;

                            /*var blob = new Blob([xhr.response], {type: ''});*/
                            var blob;
                            try {
                                blob = new Blob([xhr.response], { type: '' });
                            }
                            catch (e) {
                                window.BlobBuilder = window.BlobBuilder ||
                                    window.WebKitBlobBuilder ||
                                    window.MozBlobBuilder ||
                                    window.MSBlobBuilder;
                                if (e.name == 'TypeError') {
                                    var bb = new BlobBuilder();
                                    bb.append(xhr.response);
                                    blob = bb.getBlob("");
                                }
                            }
                            writer.write(blob);

                        }, failCallback);


                    }, failCallback);
                });

                xhr.addEventListener('error', failCallback);
                xhr.send();


                return true;

            }

            //Get App directory
            window.resolveLocalFileSystemURL(appDir, _createIssue, _fileIO.error);

            // Start the process to create the image path


        }

        //Create a private file system object
        var _fs = {};
        var _fileIO = {};

        //Initialzie the file system object
        _fileIO.init = function (fileSystem) {
            _fs = fileSystem;
            console.log('File system initialized');
        }

        _fileIO.error = function (e) {
            var msg = '';
            switch (e.code) {
                case FileError.QUOTA_EXCEEDED_ERR:
                    msg = 'QUOTA_EXCEEDED_ERR';
                    break;
                case FileError.NOT_FOUND_ERR:
                    msg = 'NOT_FOUND_ERR';
                    break;
                case FileError.SECURITY_ERR:
                    msg = 'SECURITY_ERR';
                    break;
                case FileError.INVALID_MODIFICATION_ERR:
                    msg = 'INVALID_MODIFICATION_ERR';
                    break;
                case FileError.INVALID_STATE_ERR:
                    msg = 'INVALID_STATE_ERR';
                    break;
                default:
                    msg = 'Unknown Error';
                    break;
            }
            ;

            console.log('Error: ' + msg);
        }


        //When Platform is ready init the local storage
        $ionicPlatform.ready(function () {
            if (typeof window.requestFileSystem !== 'undefined') {
                window.requestFileSystem(window.PERSISTENT, 200 * 1024 * 1024 /*100MB*/, _fileIO.init, _fileIO.error);
            }
        });

        //When user is ready initialize comic data
        $rootScope.$on('userInitialized', module.init(function (r) {
            $rootScope.$broadcast('comicInitialized');
            module.initialized = true;
        }));

        return module;
    })

    .factory('util', function ($rootScope, $http, $ionicPopup, $ionicPlatform, $state, $ionicNavBarDelegate) {
        'use strict';
        var module = {};
        //Set initial state of internet var
        module.online = false;

        ionic.Platform.ready(function () {
            //Initalize ad
            //initAd();

            //Setup event listener for back button
            document.addEventListener("backbutton", onBackKeyDown, false);

            function onBackKeyDown() {
                $ionicNavBarDelegate.back();
            }

        });

        function initAd() {

            if (window.plugins && window.plugins.AdMob) {
                var ad_units = {
                    android: {
                        interstitial: 'ca-app-pub-2148362181939197/3035797864'
                    }
                };
                var admobid = ( /(android)/i.test(navigator.userAgent) ) ? ad_units.android : ad_units.ios;

                window.plugins.AdMob.setOptions({
                    publisherId: 'pub-2148362181939197',
                    interstitialAdId: admobid.interstitial,
                    bannerAtTop: false, // set to true, to put banner at top
                    overlap: false, // set to true, to allow banner overlap webview
                    offsetTopBar: false, // set to true to avoid ios7 status bar overlap
                    isTesting: false, // receiving test ad
                    autoShow: false // auto show interstitial ad when loaded
                });

                registerAdEvents();

            }
        }

        module.shuffle = function (array) {
            var currentIndex = array.length, temporaryValue, randomIndex;

            // While there remain elements to shuffle...
            while (0 !== currentIndex) {

                // Pick a remaining element...
                randomIndex = Math.floor(Math.random() * currentIndex);
                currentIndex -= 1;

                // And swap it with the current element.
                temporaryValue = array[currentIndex];
                array[currentIndex] = array[randomIndex];
                array[randomIndex] = temporaryValue;
            }

            return array;
        }

        // optional, in case respond to events
        function registerAdEvents() {
            document.addEventListener('onReceiveAd', function () {
            });
            document.addEventListener('onFailedToReceiveAd', function (data) {
            });
            document.addEventListener('onPresentAd', function () {
            });
            document.addEventListener('onDismissAd', function () {
                console.log('dismis');
            });
            document.addEventListener('onLeaveToAd', function () {
                console.log('leave');

            });
            document.addEventListener('onReceiveInterstitialAd', function () {
            });
            document.addEventListener('onPresentInterstitialAd', function () {
            });
            document.addEventListener('onDismissInterstitialAd', function () {
            });
        }

        module.checkConnection = function (callback) {

            //Check for interwebs by manually pinging a server
            function manualCheck() {
                var xhr = new XMLHttpRequest();
                xhr.open('GET', 'http://farragocomics.com/testingtheinterwebs.jpg' + new Date().getTime(), true);
                xhr.responseType = 'blob';
                xhr.addEventListener('load', function () {
                    module.online = true
                }, false);
                xhr.upload.addEventListener('progress', function (event) {
                    module.online = true
                }, false);
                xhr.upload.addEventListener('error', function (event) {
                    module.online = false
                }, false);
                xhr.send();

                //Fire callback
                callback && callback();
            }
            if (typeof navigator.connection !== 'undefined') {

                var networkState = navigator.connection.type;
                if(networkState == 0){
                    networkState = 'unknown';
                }

                setTimeout(function () {
                    /*
                     networkState = navigator.connection.type;

                     var states = {};
                     states[Connection.UNKNOWN]  = 'Unknown connection';
                     states[Connection.ETHERNET] = 'Ethernet connection';
                     states[Connection.WIFI]     = 'WiFi connection';
                     states[Connection.CELL_2G]  = 'Cell 2G connection';
                     states[Connection.CELL_3G]  = 'Cell 3G connection';
                     states[Connection.CELL_4G]  = 'Cell 4G connection';
                     states[Connection.CELL]     = 'Cell generic connection';
                     states[Connection.NONE]     = 'No network connection';
                     */
                    //If no connection mark as offline
                    if (networkState == "none" ||networkState == "unknown") {
                        module.online = false;
                        //double check for interwebs by manually pinging a server
                        manualCheck();

                    } else {
                        module.online = true;

                        //Fire callback
                        callback && callback();
                    }

                }, 500);

                //Most likely on desktop set online to true
            } else {
                module.online = true;

                //double check for interwebs by manually pinging a server
                manualCheck();
            }
        }
        module.checkConnection();
        return module;
    });




