angular.module('farrago.controllers')
.controller('SettingsCtrl', function($scope, $ionicScrollDelegate, $http, user, $state, $ionicPopup, $stateParams, $ionicPlatform, $ionicSlideBoxDelegate) {
		
  	//Set page id
	document.body.id = 'settings-view';

    $scope.settingsForm = {};
	$scope.settingsFields = {};
  
    if(typeof analytics !== "undefined") {
		analytics.trackView('Settings');
	}	
		
	//Provide ability to move to next slide	
    $scope.submitData = function() {
	  var fields = validateFields();
	  if(fields){
	  		$ionicSlideBoxDelegate.next();
	  }
    }
	
	//Wait until things are are ready
	  ionic.DomUtil.ready(function() {  
		  
		//Fill out age field
	    var age_field = document.querySelectorAll('.no-login .age')[0];
	  	for(var i=8;i<100;i++){
	  		var option = document.createElement('option');
	  		option.innerHTML = i;
	  		option.setAttribute('value',i);
	  	 	age_field.appendChild(option);
	  	}		
				
			//Input current age
	  		document.querySelectorAll('.no-login .age')[0].value = user.data.age;
			//document.querySelector('.no-login .firstname')[0].value = user.data.firstname;		
			//Select current gender
			_selectRadio('gender', user.data.gender);
			//Select Current audience
			_selectRadio('audience', user.data.audience);
			
			//If this is a dynaimcally generated email by us don't put it in the field
			if(user.data.email.indexOf('nosignup.com') === -1 ){
				//Input current email
	  			document.querySelector('.no-login .email-container input').value = user.data.email;
			}	
				
	  });
	  

	
  	//Submit User Data
  	$scope.submitData = function(){
  		userUpdate();		
  		//First time user, just create a temp account	
  	}
	
	//Update User Information
	var userUpdate = function(){
      validateFields(function(r){      
        if(r){
            $state.go('tab.featured');
        }
      });
    };
	

	//Set Temp User
	var tempUser = {};
	
	//Validate form fields
	var validateFields = function(validateFieldsCallback){
		
		var validationErrors = [];
		//Optional Fields, get data if there is any
		tempUser.email = document.querySelector('.email-container input').value;
		tempUser.password = document.querySelector('.pass-container input').value;
        tempUser.password_confirmation = document.querySelector('.pass-container input').value;
		tempUser.age = document.querySelector('.no-login .age').value;
		tempUser.gender = _getInputValue('gender');
		tempUser.audience = _getInputValue('audience');
							
		//Check if age is filled out
		if( tempUser.age === '' || isNaN(tempUser.age) ){			
			validationErrors.push( document.querySelector('.no-login .age') );
		}
		
		//Check if gender is filled out
		if( tempUser.gender === '' || typeof tempUser.gender === 'undefined' ){			
			validationErrors.push( document.querySelector('.no-login .gender .item') );
		}
		
		//Check if audience is filled out
		if( tempUser.audience === '' || typeof tempUser.audience === 'undefined'){			
			validationErrors.push( document.querySelector('.no-login .audience .item') );
		}
		
		/*
		//Check if first name is filled out
		if( tempUser.first_name === '' || typeof tempUser.first_name === 'undefined'){			
			validationErrors.push( document.querySelector('.no-login .first_name input') );
		}
		//Check if last name is filled out
		if( tempUser.last_name === '' || typeof tempUser.last_name === 'undefined'){			
			validationErrors.push( document.querySelector('.no-login .first_name input') );
		}*/
		
		function _validateEmail(email) { 
		    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		    return re.test(email);
		} 
		
		//If they entered email, check if its filled out properly
		if( tempUser.email !== '' && !_validateEmail(tempUser.email) ){			
			validationErrors.push( document.querySelector('.no-login .email-container input') );
		}
		
		//If they entered email and password, remove temp flag
		if( tempUser.email !== '' && !_validateEmail(tempUser.email && tempUser.password !== '') ){			
			storage.set('temp', false);
		}
									
		//Check if anything didn't validate
		if(validationErrors.length > 0){
			
			for(i=0, j=validationErrors.length; i<j;  i++){
				validationErrors[i].parentNode.classList.add('error');
			}
						
			return false;	
		}else{
			
			//save some user data		
							
            //If both the email and password exist 
		    if(tempUser.email.length > 0 && tempUser.password.length > 8){
              
              //Guest: Allow user to update it, also update their account to authenicated, locking audience from now on
              if(user.data.status === 'guest'){
                                  
                  tempUser.status = 'authenticated';            
                  user.update(tempUser, function(r){
                      validateFieldsCallback(true);
                  });

              //Authenticated, needs to authenticate with /sessions to update user account
              }else if(user.data.status === 'authenticated'){
                  //Hit sessions for authentication, then allow updating
                  user.login({email:tempUser.email, password:tempUser.password}, function(r){

                      if(r.status === "signedIn"){
                          tempUser.status = 'authenticated';            
                          user.update(tempUser, function(r){
                              validateFieldsCallback(true);
                          });
                      }

                  });
              }
              
            //No username/pass, allow audience change  
            }else if(user.data.status === 'guest'){	
              
              //Reseting password if it was changed, just making sure it can't be updated since its still a guest account
              tempUser.email = user.data.email;
              tempUser.password = user.data.password;
              tempUser.password_confirmation = user.data.password;
              user.update(tempUser, function(r){
                  validateFieldsCallback(true);
              });
              
            }
										
		}
			
	}
	
	
	
	 //Check a radio button
	 function _selectRadio(name, value){
		 var radioList = document.getElementsByName(name);
		 for (i = 0; i < radioList.length; i++) {
		     if (radioList[i].value === value){
		         radioList[i].checked = true;
				 break;
		     }
		 }
	 } 

	function _getInputValue(name){
		var	inputs = document.getElementsByName(name);
		var data = [];
		for (var i = 0, length = inputs.length; i < length; i++) {
		    if (inputs[i].checked) {
				//Check for checkbox
				if(inputs[i].type === "checkbox"){
		        	// grab value from the checkbox
	        		data.push(inputs[i].value);
				}else{
		        	return inputs[i].value;
			        // only one radio can be logically checked, don't check the rest					
					break;	
				}
		    }
			//Last item, return some stuff
			if(inputs[i].type === "checkbox" && i+1 === length){
				return data;
				break;	
			}
		}		
	}
	
	

  	
	
});